(setq explicit-shell-file-name "csh")




(setq auto-mode-alist
      (append '(("\\.tex$"   . TeX-mode)
		("\\.emacs$" . lisp-mode)
		("\\.txt$"   . text-mode)		
		("\\.c$"     . c-mode)
		("\\.v$"     . verilog-mode)
		("\\.vh$"    . verilog-mode)
		("\\.vb$"    . verilog-mode)
		("\\.sv$"    . verilog-mode)
		("\\.vhd$"   . vhdl-mode)
		("\\.h$"     . c-mode)
		("\\.cpp$"   . c-mode)
		("\\.awk$"   . c-mode)
		("\\.csh$"   . c-mode)
		("\\.cc$"    . c++-mode)
		("\\.C$"     . c++-mode)
                ("\\.t$" . scheme-mode))
	      auto-mode-alist))

(add-hook 'find-file-hooks 'remove-or-convert-trailing-ctl-M)
(defun remove-or-convert-trailing-ctl-M ()
  "Propose to remove or convert trailing ^M from a file."
  (interactive)
  (save-excursion
    (goto-char (point-min))
    (if (search-forward "\^M" nil t)
        ;: a ^M is found
        (if (or (= (preceding-char) ?\^J)
                (= (following-char) ?\^J) )
            ;: Must find a way to display the buffer before this question
            (if (y-or-n-p "Remove trailing ^M ? ")
                (progn (goto-char (point-min))
                       (perform-replace "\^M" "" nil nil nil)
                       (pop-mark) )
              (message "No transformation.") )
          (if (y-or-n-p "Convert ^M into ^J ? ")
              (progn (goto-char (point-min))
                     (perform-replace "\^M" "\^J" nil nil nil)
                     (pop-mark) )
            (message "No transformation.") ) )
      ;:(message "No ^M in this file !")
      )
    ))

(defalias 'regoutputs (read-kbd-macro
"C-s output C-a 2*<C-k> 2*<C-y> 2*<C-r> 6*<C-d> reg TAB C-e C-b C-SPC C-r SPC C-f C-SPC C-e C-b ESC w C-x o ESC > C-y SPC <= SPC 0; C-x o"))

(defalias 'makeconnect
  (read-kbd-macro "C-s # C-b C-d TAB C-e <backspace> ,"))

(defalias 'downcaseconn (read-kbd-macro
"C-s = C-b C-SPC C-e ESC x downcas TAB - reg TAB RET"))

(setq verilog-file
      (expand-file-name "verilog-mode.elc"
			(expand-file-name ".xemacs" "~")))

(load-file verilog-file)

(defalias 'cleantest (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET exec RET #exec RET ESC < ESC x repl SPC s SPC RET ## RET # RET C-x C-s ESC <"))

(defalias 'dovirtex (read-kbd-macro
"ESC x repl TAB s TAB RET scripts/ RET bld_virtex SPC RET ESC < ESC x repl SPC s SPC RET .flist RET SPC xqvr300 SPC cb228 SPC 4 RET C-a C-x C-s"))

(defalias 'yum-clone
  (read-kbd-macro "C-s SPC C-b C-k C-a yum SPC -y SPC install SPC C-a C-n"))

(defalias 'cleantca (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET ib_exec RET #ib_exec RET ESC < ESC x repl SPC s SPC RET lp_exec RET #lp_exec RET ESC < ESC x repl SPC s SPC RET ## RET # RET C-x C-s"))

(defalias 'reverse_ports (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET in, RET xxx, RET ESC < ESC x repl SPC s SPC RET out, RET in, RET ESC < ESC x repl SPC s SPC RET xxx, RET out, RET ESC <"))

(defalias 'downcase_pin_name (read-kbd-macro
"C-s = C-b C-SPC C-a ESC x downcase- reg SPC RET C-n"))

(defalias 'formatpacket (read-kbd-macro
"C-s | C-b C-f C-SPC C-a C-w 2*<C-s> C-b C-f C-SPC C-a C-w C-p C-e C-d C-a C-n"))

(defalias 'mktest (read-kbd-macro
"C-s / C-b C-d SPC C-a #exec_test SPC C-e SPC lab1.txt C-a C-n"))

(defalias 'rmcvs (read-kbd-macro
"C-s cvs C-a 6*<C-k> 2*<C-s> C-a C-SPC ESC > C-w C-x C-s"))

(defalias 'newexec
  (read-kbd-macro "C-s / C-b C-d SPC C-a #exec_test SPC C-a C-n"))

(defalias 'newbuild (read-kbd-macro
"ESC x repl SPC s SPC RET constraints/ RET build_virtex_noopt SPC RET ESC < ESC x repl SPC s SPC RET .ucf RET SPC xc7a100t SPC fgg676 SPC 1 RET C-x C-s"))

(defalias 'cleaninsert (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET #insert RET insert RET C-x C-s C-a"))

(defalias 'insertall (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET insert RET #insert RET C-x C-s C-a"))

(defalias 'cleanmp4 (read-kbd-macro
"C-k ESC > mv SPC C-y SPC C-y C-r mp4 C-f 2*<C-r> 3*<C-f> ESC x repl SPC s SPC RET %20 2*RET 2*<C-r> C-f ESC x repl SPC s SPC RET - 2*RET C-e RET"))

(defalias 'missingbits (read-kbd-macro
"C-s bit C-f C-s 8*<C-w> C-a C-n C-x o 2*<C-s> C-a 2*<C-k> C-x o"))

(defalias 'dup_chipscope (read-kbd-macro
"C-x 1 ESC < C-x 2 C-x C-f foo RET ESC < C-SPC ESC > C-w C-x o C-v C-s unit<1 C-a C-SPC ESC > C-w ESC < 37*<C-n> 3*<C-p> C-SPC ESC > ESC w C-x o C-y ESC < ESC x repl SPC s SPC RET dut_1 RET dut_2 RET C-x C-s C-a ESC < ESC x repl SPC s SPC RET unit<0> RET unit<1> RET C-x C-s C-a ESC < C-SPC ESC > ESC w C-x o C-y C-x C-s"))

(defalias 'mvirtex2 (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET scripts/ RET remote_exec_4arg SPC $MACHINE1 SPC mvirtex2_remote SPC RET ESC < ESC x repl SPC s SPC RET .flist RET SPC xq2v3000 SPC cg717 SPC 4 SPC >& SPC log.x SPC & RET C-x C-s"))

(defalias 'numberlogs (read-kbd-macro
"C-s log.x C-b C-d 1 2*<C-s> C-b C-d 2 2*<C-s> C-b C-d 3 2*<C-s> C-b C-d 4 2*<C-s> C-b C-d 5 2*<C-s> C-b C-d 6 2*<C-s> C-b C-d 7 2*<C-s> C-b C-d 8 2*<C-s> C-b C-d 9 2*<C-s> C-b C-d 10 2*<C-s> C-b C-d 11 2*<C-s> C-b C-d 12 2*<C-s> C-b C-d 13 2*<C-s> C-b C-d 14 2*<C-s> C-b C-d 15 2*<C-s> C-b C-d 16 C-x C-s C-a ESC < C-s $machine C-b C-f C-d 1 C-n <backspace> 1 C-n <backspace> 1 C-n <backspace> 1 C-n <backspace> 1 C-n <backspace> 2 C-n <backspace> 2 C-n <backspace> 2 C-n <backspace> 2 C-n <backspace> 2 C-n <backspace> 3 C-n <backspace> 3 C-n <backspace> 3 C-n <backspace> 3 C-n <backspace> 3 C-n <backspace> 3 C-x C-s C-a"))

(defalias 'getpin (read-kbd-macro
"C-r pin_ C-a 4*<C-f> C-SPC C-s SPC C-b ESC x excha TAB po TAB RET ESC w C-a C-x o C-e C-y , C-x o"))

(defalias 'mkpin (read-kbd-macro
"C-s - to C-f C-k C-x o C-y TAB type SPC = SPC out,pin SPC = SPC C-x o C-a C-s _ C-b C-f C-SPC C-s SPC C-b ESC x exchange TAB po TAB RET C-w C-x o C-y ; RET C-x o C-a C-n"))

(defalias 'alt_obfuscate (read-kbd-macro
"C-s .v C-e SPC \\ C-r / C-f C-SPC C-a C-w - - source SPC enc_ C-a C-n"))

(defalias 'alt_enc (read-kbd-macro
"C-s .v C-b C-r / C-f C-SPC C-a C-w ../exc 2*<backspace> nc_tac 2*<backspace> ca SPC C-a C-n"))

(defalias 'mktestlist (read-kbd-macro
"ESC < ESC x repl SPC s SPC RET .flist 2*RET ESC < ESC x repl SPC s SPC RET scripts/ RET build_testpattern SPC RET C-x C-s"))

(defalias 'testlist (read-kbd-macro
"ESC > C-y C-r tests C-a ESC x repl SPC s SPC RET build_testpattern SPC RET TAB RET C-x C-s C-a"))

(defalias 'nc2hex
  (read-kbd-macro "C-s , C-b C-SPC C-a C-w C-e ;"))

(defalias 'hexsequence (read-kbd-macro
"C-s 'h C-b 2*<C-f> <backspace> 0 C-n <backspace> 1 C-n <backspace> 2 C-n <backspace> 3 C-n <backspace> 4 C-n <backspace> 5 C-n <backspace> 6 C-n <backspace> 7 C-n <backspace> 8 C-n <backspace> 9 C-n <backspace> A C-n <backspace> B C-n <backspace> C C-n <backspace> D C-n <backspace> E C-n <backspace> F"))
